目标是获得可以在shell命令中计算的明确状态。

我尝试了git状态,但它总是返回0,即使有项目提交。

git status
echo $?  #this is always 0

我有一个主意,但我认为这是一个相当糟糕的主意。

if [ git status | grep -i -c "[a-z]"> 2 ];
then
 code for change...
else
  code for nothing change...
fi

还有别的办法吗?


更新以下解决方案,请参阅Mark Longair的帖子

我试过了,但它引起了一个问题。

if [ -z $(git status --porcelain) ];
then
    echo "IT IS CLEAN"
else
    echo "PLEASE COMMIT YOUR CHANGE FIRST!!!"
    echo git status
fi

我得到以下错误[:??:二进制运算符

现在,我看着这个人,试着改变一下。

=================== 我希望代码,希望更好的答案 ======================

#if [ `git status | grep -i -c "$"` -lt 3 ];
# change to below code,although the above code is simple, but I think it is not strict logical
if [ `git diff --cached --exit-code HEAD^ > /dev/null && (git ls-files --other --exclude-standard --directory | grep -c -v '/$')` ];
then
        echo "PLEASE COMMIT YOUR CHANGE FIRST!!!"
    exit 1

else
    exit 0
fi

当前回答

在git源代码中有一个sh脚本,其中包括以下内容。

require_clean_work_tree () {
    git rev-parse --verify HEAD >/dev/null || exit 1
    git update-index -q --ignore-submodules --refresh
    err=0

    if ! git diff-files --quiet --ignore-submodules
    then
        echo >&2 "Cannot $1: You have unstaged changes."
        err=1
    fi

    if ! git diff-index --cached --quiet --ignore-submodules HEAD --
    then
        if [ $err = 0 ]
        then
            echo >&2 "Cannot $1: Your index contains uncommitted changes."
        else
            echo >&2 "Additionally, your index contains uncommitted changes."
        fi
        err=1
    fi

    if [ $err = 1 ]
    then
        test -n "$2" && echo >&2 "$2"
        exit 1
    fi
}

这个片段展示了如何使用git diff-files和git diff-index来查找之前已知的文件是否有任何更改。但是,它不允许您发现一个新的未知文件是否已添加到工作树中。

其他回答

git status的返回值只是告诉你git状态的退出码,而不是是否有任何修改要提交。

如果您想要一个计算机可读的git状态输出版本,请尝试

git status --porcelain

有关git状态的更多信息,请参见git状态的描述。

示例使用(脚本简单地测试git状态—porcelain提供任何输出,不需要解析):

if [ -n "$(git status --porcelain)" ]; then
  echo "there are changes";
else
  echo "no changes";
fi

请注意,你必须引用字符串来测试,即git状态的输出——瓷器。有关测试结构的更多提示,请参阅高级Bash脚本编写指南(部分字符串比较)。

测试git status—porcelain的输出是否为空的另一种方法是分别测试您关心的每个条件。人们可能并不总是关心,例如,在git状态的输出中是否有未跟踪的文件。

例如,要查看是否有任何局部的非阶段性变化,您可以查看的返回代码:

git diff --exit-code

要检查是否有任何暂存但未提交的更改,您可以使用的返回代码:

git diff --cached --exit-code

最后,如果你想知道你的工作树中是否有未被忽略的未跟踪文件,你可以测试以下命令的输出是否为空:

git ls-files --other --exclude-standard --directory

更新:您在下面询问是否可以更改该命令以排除输出中的目录。你可以通过添加——no-empty-directory来排除空目录,但要排除输出中的所有目录,我认为你必须过滤输出,例如:

git ls-files --other --exclude-standard --directory | egrep -v '/$'

对egrep使用-v表示只输出与模式不匹配的行,并且模式匹配以/结尾的任何行。

虽然不漂亮,但很管用:

git status | grep -qF 'working directory clean' || echo "DIRTY"

不确定消息是否依赖于区域设置,所以可能会在前面放一个LANG=C。

可以将git status—porcelain与简单的grep结合起来执行测试。

if git status --porcelain | grep .; then
    echo Repo is dirty
else
    echo Repo is clean
fi

我有时会把它当做简单的一行代码:

# pull from origin if our repo is clean
git status --porcelain | grep . || git pull origin master

在grep命令中添加-qs以使其静默。

我在一个脚本中使用这个:

当一切都干净的时候 1 .当存在差异或未跟踪文件时 [-z "$(git状态-瓷器)"]